routes/web.php
<?php

use App\Http\Controllers\Admin\AdminPagesController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\PhotosController as AdminPhotosController;
use App\Http\Controllers\Admin\CommentsController as AdminCommentsController;
use App\Http\Controllers\Admin\UsersController as AdminUsersController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware('language')->group(function () {
    Route::get('/', [App\Http\Controllers\PhotosController::class, 'index'])->name('home');

    Route::resource('photos', \App\Http\Controllers\PhotosController::class)->except(['edit', 'update']);

    Route::resource('users', \App\Http\Controllers\UsersController::class)->only(['show', 'edit', 'update']);

    Route::resource('photos.comments', App\Http\Controllers\PhotosCommentsController::class)
        ->only(['store'])->middleware('auth');

    Auth::routes();
});

Route::prefix('admin')->middleware('auth')->name('admin.')->group(function () {
    Route::resources(
        [
            'photos' => AdminPhotosController::class,
            'comments' => AdminCommentsController::class,
            'users' => AdminUsersController::class
        ]
    );
    Route::get('dashboard', [AdminPagesController::class, 'index'])->middleware('auth')->name('dashboard');
});

Route::get('language/{locale}', [App\Http\Controllers\LanguageSwitcherController::class, 'switcher'])
    ->name('language.switcher')->where('locale', 'en|ru');

app/Models/Photo.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Photo extends Model
{
    use HasFactory;

    protected $fillable = ['title', 'photo', 'user_id'];

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class)->latest();
    }


    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }
}

app/Http/Controllers/Admin/PhotosController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\PhotoRequest;
use App\Models\Photo;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class PhotosController extends Controller
{

    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function index()
    {
        $this->authorize('view', Auth::user());
        $photos = Photo::orderBy('id', 'desc')->paginate(12);
        return view('admin.photos.index', compact('photos'));
    }


    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function create()
    {
        $this->authorize('view', Auth::user());
        return view('admin.photos.create');
    }


    /**
     * @param PhotoRequest $request
     * @return RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function store(PhotoRequest $request): RedirectResponse
    {
        $this->authorize('view', Auth::user());
        $photo = new Photo();
        $photo->title = $request->input('title');
        $photo->user()->associate($request->user());
        $file = $request->file('photo');
        if (!is_null($file)) {
            $path = $file->store('pictures', 'public');
            $photo['photo'] = $path;
        }
        $photo->save();

        return redirect()->route('admin.photos.index');
    }


    /**
     * @param Photo $photo
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function show(Photo $photo)
    {
        $this->authorize('view', Auth::user());
        if($photo->comments->count() > 0) {
            foreach ($photo->comments as $comment) {
                $scores[] = $comment['score'];
            }
            $average = collect($scores)->avg();
        } else {
            $average = 0;
        }
        return view('admin.photos.show', compact('photo', 'average'));
    }


    /**
     * @param Photo $photo
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function edit(Photo $photo)
    {
        return view('admin.photos.edit', compact('photo'));
    }


    /**
     * @param PhotoRequest $request
     * @param Photo $photo
     * @return RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function update(PhotoRequest $request, Photo $photo): RedirectResponse
    {
        $this->authorize('view', Auth::user());
        $data = $request->all();
        if ($request->hasFile('picture')) {
            $file = $request->file('picture');
            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;
        }
        $photo->update($data);
        return redirect()->action([self::class, 'show'], ['photo' => $photo]);
    }


    /**
     * @param Photo $photo
     * @return RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function destroy(Photo $photo)
    {
        $this->authorize('view', Auth::user());
        $photo->delete();
        return redirect()->route('admin.photos.index', $photo->user_id);
    }
}

app/Http/Controllers/Api/PhotosController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Http\Resources\PhotoResource;
use App\Models\Photo;
use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;

class PhotosController extends Controller
{

    /**
     * @return \Illuminate\Http\Resources\Json\AnonymousResourceCollection
     */
    public function index(): AnonymousResourceCollection
    {
        $photos = Photo::all();
        return PhotoResource::collection($photos);
    }
}

app/Http/Controllers/PhotosController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PhotoRequest;
use App\Models\Photo;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class PhotosController extends Controller
{

    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function index()
    {
        $photos = Photo::orderBy('id', 'desc')->paginate(12);
        return view('photos.index', compact('photos'));
    }


    /**
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function create()
    {
        $this->authorize('create', Photo::class);
        return view('photos.create');
    }


    /**
     * @param PhotoRequest $request
     * @return RedirectResponse
     */
    public function store(PhotoRequest $request): RedirectResponse
    {
        $photo = new Photo();
        $photo->title = $request->input('title');
        $photo->user()->associate($request->user());
        $file = $request->file('photo');
        if (!is_null($file)) {
            $path = $file->store('pictures', 'public');
            $photo['photo'] = $path;
        }
        $photo->save();

        return redirect()->route('photos.index');
    }


    /**
     * @param Photo $photo
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View
     */
    public function show(Photo $photo)
    {
        if($photo->comments->count() > 0) {
            foreach ($photo->comments as $comment) {
                $scores[] = $comment['score'];
            }
            $average = collect($scores)->avg();
        } else {
            $average = 0;
        }
        return view('photos.show', compact('photo', 'average'));
    }

    /**
     * @param Photo $photo
     * @return RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function destroy(Photo $photo)
    {
        $this->authorize('delete', $photo);
        $photo->delete();
        return redirect()->route('users.show', $photo->user_id);
    }
}

resources/views/admin/photos/create.blade.php
@extends('layouts.admin')

@section('content')

    <div class="col main pt-5 mt-3">
        <h1>Add photo</h1>
        <form enctype="multipart/form-data" method="post" action="{{ route('admin.photos.store') }}">
            @csrf
            <div class="form-group">
                <label for="title"><b>Title</b></label>
                <input type="text" class="form-control" id="title" name="title">
                @if ($errors->has('title'))
                    <div class="alert alert-danger">
                        <ul>
                            @error('title')
                            <li>The field must be filled</li>
                            @enderror
                        </ul>
                    </div>
                @endif
            </div>

            <div class="form-group">Photo</b></label>
                <div class="custom-file">
                    <input type="file" class="custom-file-input" id="customFile" name="photo">
                    <label class="custom-file-label" for="customFile">Choose</label>
                    @if ($errors->has('photo'))
                        <div class="alert alert-danger">
                            <ul>
                                @error('photo')
                                <li>The field must be filled</li>
                                @enderror
                            </ul>
                        </div>
                    @endif
                </div>
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    </div>
@endsection

resources/views/admin/photos/edit.blade.php
@extends('layouts.admin')

@section('content')

    <div class="col main pt-5 mt-3">
        <h1>Edit photo</h1>
        <form enctype="multipart/form-data" method="post" action="{{ route('admin.photos.store') }}">
            @csrf
            <div class="form-group">
                <label for="title"><b>Title</b></label>
                <input type="text" class="form-control" id="title" name="title" value="{{$photo->title}}">
                @if ($errors->has('title'))
                    <div class="alert alert-danger">
                        <ul>
                            @error('title')
                            <li>The field must be filled</li>
                            @enderror
                        </ul>
                    </div>
                @endif

            </div>
            <div class="form-group">Photo</b></label>
                <div class="custom-file">
                    <input type="file" class="custom-file-input" id="customFile" name="photo" value="{{$photo->photo}}">
                    <label class="custom-file-label" for="customFile">Choose</label>
                    @if ($errors->has('photo'))
                        <div class="alert alert-danger">
                            <ul>
                                @error('photo')
                                <li>The field must be filled</li>
                                @enderror
                            </ul>
                        </div>
                    @endif
                </div>
            </div>
            <button type="submit" class="btn btn-primary">Submit</button>
        </form>
    </div>
@endsection

resources/views/admin/photos/index.blade.php
@extends('layouts.admin')


@section('content')

    <div class="container">
        <div style="padding-bottom: 30px;">
            <h1>Photo gallery</h1>
        </div>

        <div>
            <a href="{{route('admin.photos.create')}}"><b>Add photo</b></a>
        </div>

        <table class="table" style="padding-top: 30px">
            <thead class="thead-dark">
            <tr>
                <th scope="col">#</th>
                <th scope="col">Title</th>
                <th scope="col">Photo</th>
                <th scope="col">Actions</th>
            </tr>
            </thead>
            <tbody>



        @foreach($photos as $photo)
            <tr>
                <th scope="row">{{$photo->id}}</th>
                <td>
                    <a href="{{route('admin.photos.show', ['photo' => $photo])}}">
                        {{$photo->title}}
                    </a>
                </td>
                <td>
                    <img src="{{asset('/storage/' . $photo->photo)}}" alt="{{asset('/storage/' . $photo->photo)}}" width="50px" height="50px">
                </td>
                <td>
                    <a href="{{route('admin.photos.edit', ['photo' => $photo])}}">
                        Edit
                    </a>
                    <a href="{{route('admin.photos.show', ['photo' => $photo])}}">
                        Show
                    </a>
                    <form method="post" action="{{route('admin.photos.destroy', ['photo' => $photo])}}">
                        @method('delete')
                        @csrf
                        <button type="submit" class="btn btn-outline-danger">Delete</button>
                    </form>
                </td>
            </tr>
        @endforeach

        </tbody>
    </table>

    <div class="row justify-content-md-center p-5">
        <div class="col-md-auto">
            {{ $photos->links('pagination::bootstrap-4') }}
        </div>
    </div>

@endsection

resources/views/admin/photos/show.blade.php
@extends('layouts.admin')

@section('content')

    <div class="container">
        <div class="card" style="width: 26rem">
            <img class="card-img-top" src="{{asset('/storage/' . $photo->photo)}}" alt="{{$photo->photo}}">
            <div class="card-body">
                <h5 class="card-title"><b>{{$photo->title}}</b></h5>
                <a href="{{route('users.show', ['user' => $photo->user])}}"><b>@lang('messages.by'): {{$photo->user->name}}</b></a>
                <h6><b>@lang('messages.average'): {{round($average)}}</b></h6>
            </div>
            <div class="card-body">
                <a href="{{route('photos.index')}}" class="btn btn-primary btn-sm"><b>@lang('messages.back')</b></a>
            </div>
        </div>

        <div id="accordion">
            <div class="card">
                <div class="card-header" id="headingOne">
                    <h5 class="mb-0">
                        <button class="btn btn-link collapsed" data-toggle="collapse" data-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                            @lang('messages.comments')
                        </button>
                    </h5>
                </div>

                <div id="collapseOne" class="collapse" aria-labelledby="headingOne" data-parent="#accordion">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-8 scrollit">
                                @foreach($photo->comments as $comment)
                                    <div class="">
                                        <div class="media g-mb-30 media-comment">
                                            <div class="media-body u-shadow-v18 g-bg-secondary g-pa-30">
                                                <div class="g-mb-15">
                                                    <h5 class="h5 g-color-gray-dark-v1 mb-0">{{$comment->user->name}}</h5>
                                                </div>
                                                <p>
                                                    {{$comment->score}}
                                                </p>
                                                <p>
                                                    {{$comment->body}}
                                                </p>
                                            </div>
                                        </div>
                                    </div>
                                @endforeach
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            @if(Auth::check())
                <div class="col-4 fixed">
                    <div class="comment-form">
                        <form id="create-comment">
                            @csrf
                            <input type="hidden" id="photo_id" value="{{$photo->id}}">
                            <div class="form-group">
                                <label for="score">@lang('messages.score')</label>
                                <select class="custom-select" name="score" required>
                                    <option value="">@lang('messages.choose').</option>
                                    <option value="1">1</option>
                                    <option value="2">2</option>
                                    <option value="3">3</option>
                                    <option value="4">4</option>
                                    <option value="5">5</option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="commentFormControl">@lang('messages.comment')</label>
                                <textarea name="body" class="form-control" id="commentFormControl" rows="3" required></textarea>
                            </div>
                            <button id="create-comment-btn" type="submit" class="btn btn-outline-primary btn-sm btn-block">
                                @lang('messages.add_comment')
                            </button>
                        </form>
                    </div>
                </div>
            @endif
        </div>
    </div>
@endsection